unit Utils;

interface
const

{$EXTERNALSYM CLSCTX_INPROC_SERVER}
  CLSCTX_INPROC_SERVER = 1;
{$EXTERNALSYM CLSCTX_INPROC_HANDLER}
  CLSCTX_INPROC_HANDLER = 2;
{$EXTERNALSYM CLSCTX_LOCAL_SERVER}
  CLSCTX_LOCAL_SERVER = 4;
{$EXTERNALSYM CLSCTX_INPROC_SERVER16}
  CLSCTX_INPROC_SERVER16 = 8;
{$EXTERNALSYM CLSCTX_REMOTE_SERVER}
  CLSCTX_REMOTE_SERVER = $10;
{$EXTERNALSYM CLSCTX_INPROC_HANDLER16}
  CLSCTX_INPROC_HANDLER16 = $20;
{$EXTERNALSYM CLSCTX_INPROC_SERVERX86}
  CLSCTX_INPROC_SERVERX86 = $40;
{$EXTERNALSYM CLSCTX_INPROC_HANDLERX86}
  CLSCTX_INPROC_HANDLERX86 = $80;

{ from OBJBASE }
{$EXTERNALSYM CLSCTX_ALL}
  CLSCTX_ALL = CLSCTX_INPROC_SERVER or CLSCTX_INPROC_HANDLER or
    CLSCTX_LOCAL_SERVER;
{$EXTERNALSYM CLSCTX_INPROC}
  CLSCTX_INPROC = CLSCTX_INPROC_SERVER or CLSCTX_INPROC_HANDLER;
{$EXTERNALSYM CLSCTX_SERVER}
  CLSCTX_SERVER = CLSCTX_INPROC_SERVER or CLSCTX_LOCAL_SERVER;

{$EXTERNALSYM VT_EMPTY}
  VT_EMPTY = 0; { [V]   [P]  nothing                     }
{$EXTERNALSYM VT_NULL}
  VT_NULL = 1; { [V]        SQL style Null              }
{$EXTERNALSYM VT_I2}
  VT_I2 = 2; { [V][T][P]  2 byte signed int           }
{$EXTERNALSYM VT_I4}
  VT_I4 = 3; { [V][T][P]  4 byte signed int           }
{$EXTERNALSYM VT_R4}
  VT_R4 = 4; { [V][T][P]  4 byte real                 }
{$EXTERNALSYM VT_R8}
  VT_R8 = 5; { [V][T][P]  8 byte real                 }
{$EXTERNALSYM VT_CY}
  VT_CY = 6; { [V][T][P]  currency                    }
{$EXTERNALSYM VT_DATE}
  VT_DATE = 7; { [V][T][P]  date                        }
{$EXTERNALSYM VT_BSTR}
  VT_BSTR = 8; { [V][T][P]  binary string               }
{$EXTERNALSYM VT_DISPATCH}
  VT_DISPATCH = 9; { [V][T]     IDispatch FAR*              }
{$EXTERNALSYM VT_ERROR}
  VT_ERROR = 10; { [V][T]     SCODE                       }
{$EXTERNALSYM VT_BOOL}
  VT_BOOL = 11; { [V][T][P]  True=-1, False=0            }
{$EXTERNALSYM VT_VARIANT}
  VT_VARIANT = 12; { [V][T][P]  VARIANT FAR*                }
{$EXTERNALSYM VT_UNKNOWN}
  VT_UNKNOWN = 13; { [V][T]     IUnknown FAR*               }
{$EXTERNALSYM VT_DECIMAL}
  VT_DECIMAL = 14; { [V][T]   [S]  16 byte fixed point      }

{$EXTERNALSYM VT_I1}
  VT_I1 = 16; {    [T]     signed char                 }
{$EXTERNALSYM VT_UI1}
  VT_UI1 = 17; {    [T]     unsigned char               }
{$EXTERNALSYM VT_UI2}
  VT_UI2 = 18; {    [T]     unsigned short              }
{$EXTERNALSYM VT_UI4}
  VT_UI4 = 19; {    [T]     unsigned long               }
{$EXTERNALSYM VT_I8}
  VT_I8 = 20; {    [T][P]  signed 64-bit int           }
{$EXTERNALSYM VT_UI8}
  VT_UI8 = 21; {    [T]     unsigned 64-bit int         }
{$EXTERNALSYM VT_INT}
  VT_INT = 22; {    [T]     signed machine int          }
{$EXTERNALSYM VT_UINT}
  VT_UINT = 23; {    [T]     unsigned machine int        }
{$EXTERNALSYM VT_VOID}
  VT_VOID = 24; {    [T]     C style void                }
{$EXTERNALSYM VT_HRESULT}
  VT_HRESULT = 25; {    [T]                                 }
{$EXTERNALSYM VT_PTR}
  VT_PTR = 26; {    [T]     pointer type                }
{$EXTERNALSYM VT_SAFEARRAY}
  VT_SAFEARRAY = 27; {    [T]     (use VT_ARRAY in VARIANT)   }
{$EXTERNALSYM VT_CARRAY}
  VT_CARRAY = 28; {    [T]     C style array               }
{$EXTERNALSYM VT_USERDEFINED}
  VT_USERDEFINED = 29; {    [T]     user defined type          }
{$EXTERNALSYM VT_LPSTR}
  VT_LPSTR = 30; {    [T][P]  null terminated string      }
{$EXTERNALSYM VT_LPWSTR}
  VT_LPWSTR = 31; {    [T][P]  wide null terminated string }

{$EXTERNALSYM VT_FILETIME}
  VT_FILETIME = 64; {       [P]  FILETIME                    }
{$EXTERNALSYM VT_BLOB}
  VT_BLOB = 65; {       [P]  Length prefixed bytes       }
{$EXTERNALSYM VT_STREAM}
  VT_STREAM = 66; {       [P]  Name of the stream follows  }
{$EXTERNALSYM VT_STORAGE}
  VT_STORAGE = 67; {       [P]  Name of the storage follows }
{$EXTERNALSYM VT_STREAMED_OBJECT}
  VT_STREAMED_OBJECT = 68; {       [P]  Stream contains an object   }
{$EXTERNALSYM VT_STORED_OBJECT}
  VT_STORED_OBJECT = 69; {       [P]  Storage contains an object  }
{$EXTERNALSYM VT_BLOB_OBJECT}
  VT_BLOB_OBJECT = 70; {       [P]  Blob contains an object     }
{$EXTERNALSYM VT_CF}
  VT_CF = 71; {       [P]  Clipboard format            }
{$EXTERNALSYM VT_CLSID}
  VT_CLSID = 72; {       [P]  A Class ID                  }

{$EXTERNALSYM VT_VECTOR}
  VT_VECTOR = $1000; {       [P]  simple counted array        }
{$EXTERNALSYM VT_ARRAY}
  VT_ARRAY = $2000; { [V]        SAFEARRAY*                  }
{$EXTERNALSYM VT_BYREF}
  VT_BYREF = $4000; { [V]                                    }
{$EXTERNALSYM VT_RESERVED}
  VT_RESERVED = $8000;
{$EXTERNALSYM VT_ILLEGAL}
  VT_ILLEGAL = $FFFF;
{$EXTERNALSYM VT_ILLEGALMASKED}
  VT_ILLEGALMASKED = $0FFF;
{$EXTERNALSYM VT_TYPEMASK}
  VT_TYPEMASK = $0FFF;


type

  TDispID = Longint;
  TOleEnum = type LongWord;
  TCLSID = TGUID;
  TIID = TGUID;
  DWORD = LongWord;
  HWND = DWORD;
  UINT = LongWord;
  ULONG = Cardinal;
  TOleDate = Double;
{$EXTERNALSYM ULONG}
  PULONG = ^ULONG;
{$EXTERNALSYM PULONG}

  _FILETIME = record
    dwLowDateTime: DWORD;
    dwHighDateTime: DWORD;
  end;
{$EXTERNALSYM _FILETIME}
  TFileTime = _FILETIME;
  LPCWSTR = PWideChar;
  WPARAM = Longint;
{$EXTERNALSYM WPARAM}
  LONGLONG = Int64;
  tagDEC = packed record
    wReserved: Word;
    case Integer of
      0: (scale, sign: Byte; Hi32: Longint;
        case Integer of
          0: (Lo32, Mid32: Longint);
          1: (Lo64: LONGLONG));
      1: (signscale: Word);
  end;

  TDecimal = tagDEC;
  PDecimal = ^TDecimal;

  tagSAFEARRAYBOUND = record
    cElements: Longint;
    lLbound: Longint;
  end;

  TSafeArrayBound = tagSAFEARRAYBOUND;
  tagSAFEARRAY = record
    cDims: Word;
    fFeatures: Word;
    cbElements: Longint;
    cLocks: Longint;
    pvData: Pointer;
    rgsabound: array[0..0] of TSafeArrayBound;
  end;

  TSafeArray = tagSAFEARRAY;
  PSafeArray = ^TSafeArray;
  TOleBool = WordBool;
  tagVARIANT = record
    vt: TVarType;
    wReserved1: Word;
    wReserved2: Word;
    wReserved3: Word;
    case Integer of
      VT_UI1: (bVal: Byte);
      VT_I2: (iVal: Smallint);
      VT_I4: (lVal: Longint);
      VT_R4: (fltVal: Single);
      VT_R8: (dblVal: Double);
      VT_BOOL: (vbool: TOleBool);
      VT_ERROR: (scode: HResult);
      VT_CY: (cyVal: Currency);
      VT_DATE: (date: TOleDate);
      VT_BSTR: (bstrVal: PWideChar {WideString});
      VT_UNKNOWN: (unkVal: Pointer {IUnknown});
      VT_DISPATCH: (dispVal: Pointer {IDispatch});
      VT_ARRAY: (parray: PSafeArray);
      VT_BYREF or VT_UI1: (pbVal: ^Byte);
      VT_BYREF or VT_I2: (piVal: ^Smallint);
      VT_BYREF or VT_I4: (plVal: ^Longint);
      VT_BYREF or VT_R4: (pfltVal: ^Single);
      VT_BYREF or VT_R8: (pdblVal: ^Double);
      VT_BYREF or VT_BOOL: (pbool: ^TOleBool);
      VT_BYREF or VT_ERROR: (pscode: ^HResult);
      VT_BYREF or VT_CY: (pcyVal: ^Currency);
      VT_BYREF or VT_DATE: (pdate: ^TOleDate);
      VT_BYREF or VT_BSTR: (pbstrVal: ^WideString);
      VT_BYREF or VT_UNKNOWN: (punkVal: ^IUnknown);
      VT_BYREF or VT_DISPATCH: (pdispVal: ^IDispatch);
      VT_BYREF or VT_ARRAY: (pparray: ^PSafeArray);
      VT_BYREF or VT_VARIANT: (pvarVal: PVariant);
      VT_BYREF: (byRef: Pointer);
      VT_I1: (cVal: Char);
      VT_UI2: (uiVal: Word);
      VT_UI4: (ulVal: LongWord);
      VT_INT: (intVal: Integer);
      VT_UINT: (uintVal: LongWord);
      VT_BYREF or VT_DECIMAL: (pdecVal: PDecimal);
      VT_BYREF or VT_I1: (pcVal: PChar);
      VT_BYREF or VT_UI2: (puiVal: PWord);
      VT_BYREF or VT_UI4: (pulVal: PInteger);
      VT_BYREF or VT_INT: (pintVal: PInteger);
      VT_BYREF or VT_UINT: (puintVal: PLongWord);
  end;

  TVariantArg = tagVARIANT;
  PVariantArg = ^TVariantArg;

  PVariantArgList = ^TVariantArgList;
  TVariantArgList = array[0..65535] of TVariantArg;

  a = Longint;

  PDispIDList = ^TDispIDList;
  TDispIDList = array[0..65535] of TDispID;

  tagDISPPARAMS = record
    rgvarg: PVariantArgList;
    rgdispidNamedArgs: PDispIDList;
    cArgs: Longint;
    cNamedArgs: Longint;
  end;


  TDispParams = tagDISPPARAMS;
  PDispParams = ^TDispParams;


{$EXTERNALSYM CoDisconnectObject}
function CoDisconnectObject(unk: IUnknown; dwReserved: Longint): HResult; stdcall;


{$EXTERNALSYM CoCreateInstance}
function CoCreateInstance(const clsid: TCLSID; unkOuter: IUnknown;
  dwClsContext: Longint; const iid: TIID; out pv): HResult; stdcall;

{$EXTERNALSYM CoInitialize}
function CoInitialize(pvReserved: Pointer): HResult; stdcall;

procedure ZeroMemory(Destination: Pointer; Length: DWORD);
{$EXTERNALSYM ZeroMemory}

{$EXTERNALSYM CharUpperBuff}
function CharUpperBuff(lpsz: PChar; cchLength: DWORD): DWORD; stdcall;

{$EXTERNALSYM VerLanguageName}
function VerLanguageName(wLang: DWORD; szLang: PChar; nSize: DWORD): DWORD; stdcall;

function MakeWParam(l, h: Word): WPARAM;
{$EXTERNALSYM MakeWParam}

{$EXTERNALSYM IsEqualIID}
function IsEqualIID(const iid1, iid2: TIID): Boolean; stdcall;

function CreateComObject(const ClassID: TGUID): IUnknown;

{$EXTERNALSYM GetActiveObject}
function GetActiveObject(const clsid: TCLSID; pvReserved: Pointer;
  out unk: IUnknown): HResult; stdcall;

{$EXTERNALSYM Succeeded}
function Succeeded(Res: HResult): Boolean;


function Format(const Format: string; const Args: array of const): string;
function IntToStr(Value: Integer): string;
procedure FreeAndNil(var Obj);
function AnsiUpperCase(const S: string): string;
var
  EmptyParam: OleVariant;
implementation

function CoDisconnectObject; external 'ole32.dll' name 'CoDisconnectObject';
function CoCreateInstance; external 'ole32.dll' name 'CoCreateInstance';
function CoInitialize; external 'ole32.dll' name 'CoInitialize';
function CharUpperBuff; external 'user32.dll' name 'CharUpperBuffA';
function VerLanguageName; external 'kernel32.dll' name 'VerLanguageNameA';
function IsEqualIID; external 'ole32.dll' name 'IsEqualGUID';
function GetActiveObject;               external 'oleaut32.dll' name 'GetActiveObject';


function MakeLong(A, B: Word): Longint;
begin
  Result := A or B shl 16;
end;

function MakeWParam(l, h: Word): WPARAM;
begin
  Result := MakeLong(l, h);
end;

function Succeeded(Res: HResult): Boolean;
begin
  Result := Res and $80000000 = 0;
end;

procedure ZeroMemory(Destination: Pointer; Length: DWORD);
begin
  FillChar(Destination^, Length, 0);
end;

function CreateComObject(const ClassID: TGUID): IUnknown;
begin
  CoCreateInstance(ClassID, nil, CLSCTX_INPROC_SERVER or CLSCTX_LOCAL_SERVER, IUnknown, Result);
end;


function Format(const Format: string; const Args: array of const): string;
begin

end;


procedure CvtInt;
{ IN:
    EAX:  The integer value to be converted to text
    ESI:  Ptr to the right-hand side of the output buffer:  LEA ESI, StrBuf[16]
    ECX:  Base for conversion: 0 for signed decimal, 10 or 16 for unsigned
    EDX:  Precision: zero padded minimum field width
  OUT:
    ESI:  Ptr to start of converted text (not start of buffer)
    ECX:  Length of converted text
}
asm
        OR      CL,CL
        JNZ     @CvtLoop
@C1:    OR      EAX,EAX
        JNS     @C2
        NEG     EAX
        CALL    @C2
        MOV     AL,'-'
        INC     ECX
        DEC     ESI
        MOV     [ESI],AL
        RET
@C2:    MOV     ECX,10

@CvtLoop:
        PUSH    EDX
        PUSH    ESI
@D1:    XOR     EDX,EDX
        DIV     ECX
        DEC     ESI
        ADD     DL,'0'
        CMP     DL,'0'+10
        JB      @D2
        ADD     DL,('A'-'0')-10
@D2:    MOV     [ESI],DL
        OR      EAX,EAX
        JNE     @D1
        POP     ECX
        POP     EDX
        SUB     ECX,ESI
        SUB     EDX,ECX
        JBE     @D5
        ADD     ECX,EDX
        MOV     AL,'0'
        SUB     ESI,EDX
        JMP     @z
@zloop: MOV     [ESI+EDX],AL
@z:     DEC     EDX
        JNZ     @zloop
        MOV     [ESI],AL
@D5:
end;

function IntToStr(Value: Integer): string;
//  FmtStr(Result, '%d', [Value]);
asm
        PUSH    ESI
        MOV     ESI, ESP
        SUB     ESP, 16
        XOR     ECX, ECX       // base: 0 for signed decimal
        PUSH    EDX            // result ptr
        XOR     EDX, EDX       // zero filled field width: 0 for no leading zeros
        CALL    CvtInt
        MOV     EDX, ESI
        POP     EAX            // result ptr
        CALL    System.@LStrFromPCharLen
        ADD     ESP, 16
        POP     ESI
end;

procedure FreeAndNil(var Obj);
var
  Temp: TObject;
begin
  Temp := TObject(Obj);
  Pointer(Obj) := nil;
  Temp.Free;
end;

function AnsiUpperCase(const S: string): string;
var
  Len: Integer;
begin
  Len := Length(S);
  SetString(Result, PChar(S), Len);
  if Len > 0 then CharUpperBuff(Pointer(Result), Len);
end;



end.

